]> git.ipfire.org Git - thirdparty/git.git/blob - git-filter-branch.sh
refs.c: change ref_transaction_update() to do error checking and return status
[thirdparty/git.git] / git-filter-branch.sh
1 #!/bin/sh
2 #
3 # Rewrite revision history
4 # Copyright (c) Petr Baudis, 2006
5 # Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
6 #
7 # Lets you rewrite the revision history of the current branch, creating
8 # a new branch. You can specify a number of filters to modify the commits,
9 # files and trees.
10
11 # The following functions will also be available in the commit filter:
12
13 functions=$(cat << \EOF
14 warn () {
15 echo "$*" >&2
16 }
17
18 map()
19 {
20 # if it was not rewritten, take the original
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
26 fi
27 }
28
29 # if you run 'skip_commit "$@"' in a commit filter, it will print
30 # the (mapped) parents, effectively skipping the commit.
31
32 skip_commit()
33 {
34 shift;
35 while [ -n "$1" ];
36 do
37 shift;
38 map "$1";
39 shift;
40 done;
41 }
42
43 # if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44 # it will skip commits that leave the tree untouched, commit the other.
45 git_commit_non_empty_tree()
46 {
47 if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
48 map "$3"
49 else
50 git commit-tree "$@"
51 fi
52 }
53 # override die(): this version puts in an extra line break, so that
54 # the progress is still visible
55
56 die()
57 {
58 echo >&2
59 echo "$*" >&2
60 exit 1
61 }
62 EOF
63 )
64
65 eval "$functions"
66
67 finish_ident() {
68 # Ensure non-empty id name.
69 echo "case \"\$GIT_$1_NAME\" in \"\") GIT_$1_NAME=\"\${GIT_$1_EMAIL%%@*}\" && export GIT_$1_NAME;; esac"
70 # And make sure everything is exported.
71 echo "export GIT_$1_NAME"
72 echo "export GIT_$1_EMAIL"
73 echo "export GIT_$1_DATE"
74 }
75
76 set_ident () {
77 parse_ident_from_commit author AUTHOR committer COMMITTER
78 finish_ident AUTHOR
79 finish_ident COMMITTER
80 }
81
82 USAGE="[--env-filter <command>] [--tree-filter <command>]
83 [--index-filter <command>] [--parent-filter <command>]
84 [--msg-filter <command>] [--commit-filter <command>]
85 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
86 [--original <namespace>] [-d <directory>] [-f | --force]
87 [<rev-list options>...]"
88
89 OPTIONS_SPEC=
90 . git-sh-setup
91
92 if [ "$(is_bare_repository)" = false ]; then
93 require_clean_work_tree 'rewrite branches'
94 fi
95
96 tempdir=.git-rewrite
97 filter_env=
98 filter_tree=
99 filter_index=
100 filter_parent=
101 filter_msg=cat
102 filter_commit=
103 filter_tag_name=
104 filter_subdir=
105 orig_namespace=refs/original/
106 force=
107 prune_empty=
108 remap_to_ancestor=
109 while :
110 do
111 case "$1" in
112 --)
113 shift
114 break
115 ;;
116 --force|-f)
117 shift
118 force=t
119 continue
120 ;;
121 --remap-to-ancestor)
122 # deprecated ($remap_to_ancestor is set now automatically)
123 shift
124 remap_to_ancestor=t
125 continue
126 ;;
127 --prune-empty)
128 shift
129 prune_empty=t
130 continue
131 ;;
132 -*)
133 ;;
134 *)
135 break;
136 esac
137
138 # all switches take one argument
139 ARG="$1"
140 case "$#" in 1) usage ;; esac
141 shift
142 OPTARG="$1"
143 shift
144
145 case "$ARG" in
146 -d)
147 tempdir="$OPTARG"
148 ;;
149 --env-filter)
150 filter_env="$OPTARG"
151 ;;
152 --tree-filter)
153 filter_tree="$OPTARG"
154 ;;
155 --index-filter)
156 filter_index="$OPTARG"
157 ;;
158 --parent-filter)
159 filter_parent="$OPTARG"
160 ;;
161 --msg-filter)
162 filter_msg="$OPTARG"
163 ;;
164 --commit-filter)
165 filter_commit="$functions; $OPTARG"
166 ;;
167 --tag-name-filter)
168 filter_tag_name="$OPTARG"
169 ;;
170 --subdirectory-filter)
171 filter_subdir="$OPTARG"
172 remap_to_ancestor=t
173 ;;
174 --original)
175 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
176 ;;
177 *)
178 usage
179 ;;
180 esac
181 done
182
183 case "$prune_empty,$filter_commit" in
184 ,)
185 filter_commit='git commit-tree "$@"';;
186 t,)
187 filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
188 ,*)
189 ;;
190 *)
191 die "Cannot set --prune-empty and --commit-filter at the same time"
192 esac
193
194 case "$force" in
195 t)
196 rm -rf "$tempdir"
197 ;;
198 '')
199 test -d "$tempdir" &&
200 die "$tempdir already exists, please remove it"
201 esac
202 orig_dir=$(pwd)
203 mkdir -p "$tempdir/t" &&
204 tempdir="$(cd "$tempdir"; pwd)" &&
205 cd "$tempdir/t" &&
206 workdir="$(pwd)" ||
207 die ""
208
209 # Remove tempdir on exit
210 trap 'cd "$orig_dir"; rm -rf "$tempdir"' 0
211
212 ORIG_GIT_DIR="$GIT_DIR"
213 ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
214 ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
215 GIT_WORK_TREE=.
216 export GIT_DIR GIT_WORK_TREE
217
218 # Make sure refs/original is empty
219 git for-each-ref > "$tempdir"/backup-refs || exit
220 while read sha1 type name
221 do
222 case "$force,$name" in
223 ,$orig_namespace*)
224 die "Cannot create a new backup.
225 A previous backup already exists in $orig_namespace
226 Force overwriting the backup with -f"
227 ;;
228 t,$orig_namespace*)
229 git update-ref -d "$name" $sha1
230 ;;
231 esac
232 done < "$tempdir"/backup-refs
233
234 # The refs should be updated if their heads were rewritten
235 git rev-parse --no-flags --revs-only --symbolic-full-name \
236 --default HEAD "$@" > "$tempdir"/raw-heads || exit
237 sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
238
239 test -s "$tempdir"/heads ||
240 die "Which ref do you want to rewrite?"
241
242 GIT_INDEX_FILE="$(pwd)/../index"
243 export GIT_INDEX_FILE
244
245 # map old->new commit ids for rewriting parents
246 mkdir ../map || die "Could not create map/ directory"
247
248 # we need "--" only if there are no path arguments in $@
249 nonrevs=$(git rev-parse --no-revs "$@") || exit
250 if test -z "$nonrevs"
251 then
252 dashdash=--
253 else
254 dashdash=
255 remap_to_ancestor=t
256 fi
257
258 git rev-parse --revs-only "$@" >../parse
259
260 case "$filter_subdir" in
261 "")
262 eval set -- "$(git rev-parse --sq --no-revs "$@")"
263 ;;
264 *)
265 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
266 "$filter_subdir")"
267 ;;
268 esac
269
270 git rev-list --reverse --topo-order --default HEAD \
271 --parents --simplify-merges --stdin "$@" <../parse >../revs ||
272 die "Could not get the commits"
273 commits=$(wc -l <../revs | tr -d " ")
274
275 test $commits -eq 0 && die "Found nothing to rewrite"
276
277 # Rewrite the commits
278
279 git_filter_branch__commit_count=0
280 while read commit parents; do
281 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
282 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
283
284 case "$filter_subdir" in
285 "")
286 GIT_ALLOW_NULL_SHA1=1 git read-tree -i -m $commit
287 ;;
288 *)
289 # The commit may not have the subdirectory at all
290 err=$(GIT_ALLOW_NULL_SHA1=1 \
291 git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
292 if ! git rev-parse -q --verify $commit:"$filter_subdir"
293 then
294 rm -f "$GIT_INDEX_FILE"
295 else
296 echo >&2 "$err"
297 false
298 fi
299 }
300 esac || die "Could not initialize the index"
301
302 GIT_COMMIT=$commit
303 export GIT_COMMIT
304 git cat-file commit "$commit" >../commit ||
305 die "Cannot read commit $commit"
306
307 eval "$(set_ident <../commit)" ||
308 die "setting author/committer failed for commit $commit"
309 eval "$filter_env" < /dev/null ||
310 die "env filter failed: $filter_env"
311
312 if [ "$filter_tree" ]; then
313 git checkout-index -f -u -a ||
314 die "Could not checkout the index"
315 # files that $commit removed are now still in the working tree;
316 # remove them, else they would be added again
317 git clean -d -q -f -x
318 eval "$filter_tree" < /dev/null ||
319 die "tree filter failed: $filter_tree"
320
321 (
322 git diff-index -r --name-only --ignore-submodules $commit &&
323 git ls-files --others
324 ) > "$tempdir"/tree-state || exit
325 git update-index --add --replace --remove --stdin \
326 < "$tempdir"/tree-state || exit
327 fi
328
329 eval "$filter_index" < /dev/null ||
330 die "index filter failed: $filter_index"
331
332 parentstr=
333 for parent in $parents; do
334 for reparent in $(map "$parent"); do
335 parentstr="$parentstr -p $reparent"
336 done
337 done
338 if [ "$filter_parent" ]; then
339 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
340 die "parent filter failed: $filter_parent"
341 fi
342
343 sed -e '1,/^$/d' <../commit | \
344 eval "$filter_msg" > ../message ||
345 die "msg filter failed: $filter_msg"
346 workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
347 $(git write-tree) $parentstr < ../message > ../map/$commit ||
348 die "could not write rewritten commit"
349 done <../revs
350
351 # If we are filtering for paths, as in the case of a subdirectory
352 # filter, it is possible that a specified head is not in the set of
353 # rewritten commits, because it was pruned by the revision walker.
354 # Ancestor remapping fixes this by mapping these heads to the unique
355 # nearest ancestor that survived the pruning.
356
357 if test "$remap_to_ancestor" = t
358 then
359 while read ref
360 do
361 sha1=$(git rev-parse "$ref"^0)
362 test -f "$workdir"/../map/$sha1 && continue
363 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
364 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
365 done < "$tempdir"/heads
366 fi
367
368 # Finally update the refs
369
370 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
371 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
372 echo
373 while read ref
374 do
375 # avoid rewriting a ref twice
376 test -f "$orig_namespace$ref" && continue
377
378 sha1=$(git rev-parse "$ref"^0)
379 rewritten=$(map $sha1)
380
381 test $sha1 = "$rewritten" &&
382 warn "WARNING: Ref '$ref' is unchanged" &&
383 continue
384
385 case "$rewritten" in
386 '')
387 echo "Ref '$ref' was deleted"
388 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
389 die "Could not delete $ref"
390 ;;
391 $_x40)
392 echo "Ref '$ref' was rewritten"
393 if ! git update-ref -m "filter-branch: rewrite" \
394 "$ref" $rewritten $sha1 2>/dev/null; then
395 if test $(git cat-file -t "$ref") = tag; then
396 if test -z "$filter_tag_name"; then
397 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
398 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
399 fi
400 else
401 die "Could not rewrite $ref"
402 fi
403 fi
404 ;;
405 *)
406 # NEEDSWORK: possibly add -Werror, making this an error
407 warn "WARNING: '$ref' was rewritten into multiple commits:"
408 warn "$rewritten"
409 warn "WARNING: Ref '$ref' points to the first one now."
410 rewritten=$(echo "$rewritten" | head -n 1)
411 git update-ref -m "filter-branch: rewrite to first" \
412 "$ref" $rewritten $sha1 ||
413 die "Could not rewrite $ref"
414 ;;
415 esac
416 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
417 exit
418 done < "$tempdir"/heads
419
420 # TODO: This should possibly go, with the semantics that all positive given
421 # refs are updated, and their original heads stored in refs/original/
422 # Filter tags
423
424 if [ "$filter_tag_name" ]; then
425 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
426 while read sha1 type ref; do
427 ref="${ref#refs/tags/}"
428 # XXX: Rewrite tagged trees as well?
429 if [ "$type" != "commit" -a "$type" != "tag" ]; then
430 continue;
431 fi
432
433 if [ "$type" = "tag" ]; then
434 # Dereference to a commit
435 sha1t="$sha1"
436 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
437 fi
438
439 [ -f "../map/$sha1" ] || continue
440 new_sha1="$(cat "../map/$sha1")"
441 GIT_COMMIT="$sha1"
442 export GIT_COMMIT
443 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
444 die "tag name filter failed: $filter_tag_name"
445
446 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
447
448 if [ "$type" = "tag" ]; then
449 new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
450 "$new_sha1" "$new_ref"
451 git cat-file tag "$ref" |
452 sed -n \
453 -e '1,/^$/{
454 /^object /d
455 /^type /d
456 /^tag /d
457 }' \
458 -e '/^-----BEGIN PGP SIGNATURE-----/q' \
459 -e 'p' ) |
460 git mktag) ||
461 die "Could not create new tag object for $ref"
462 if git cat-file tag "$ref" | \
463 sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
464 then
465 warn "gpg signature stripped from tag object $sha1t"
466 fi
467 fi
468
469 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
470 die "Could not write tag $new_ref"
471 done
472 fi
473
474 cd "$orig_dir"
475 rm -rf "$tempdir"
476
477 trap - 0
478
479 unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
480 test -z "$ORIG_GIT_DIR" || {
481 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
482 }
483 test -z "$ORIG_GIT_WORK_TREE" || {
484 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
485 export GIT_WORK_TREE
486 }
487 test -z "$ORIG_GIT_INDEX_FILE" || {
488 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
489 export GIT_INDEX_FILE
490 }
491
492 if [ "$(is_bare_repository)" = false ]; then
493 git read-tree -u -m HEAD || exit
494 fi
495
496 exit 0